import * as redux from 'redux';
import * as _reduxjs_toolkit from '@reduxjs/toolkit';
import * as immer from 'immer';

declare const sliceName = "users";
declare const initialState: {
    activationCode: undefined;
    byId: {};
    currentUser: null;
    currentSession: {};
    customColumns: never[];
    qrCode: null;
    globalSettings: {
        id_attribute: undefined;
        previousFilters: never[];
        previousPhases: never[];
        retries: number;
    };
    permissionSetsById: {
        [x: string]: {
            name: string;
            result: {
                userManagement: string[];
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            } | {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            } | {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            result: {
                auditlog: string[];
                userManagement?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                releases: {
                    "All releases": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                tenantManagement: string[];
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                deployments: string[];
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
            };
        } | {
            name: string;
            result: {
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
            };
        };
    };
    rolesById: {
        [x: string]: {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        };
    };
    settingsInitialized: boolean;
    showConnectDeviceDialog: boolean;
    showFeedbackDialog: boolean;
    showStartupNotification: boolean;
    tooltips: {
        byId: {};
    };
    userSettings: {
        columnSelection: never[];
        onboarding: {};
    };
    userSettingsInitialized: boolean;
};
declare const usersSlice: _reduxjs_toolkit.Slice<{
    activationCode: undefined;
    byId: {};
    currentUser: null;
    currentSession: {};
    customColumns: never[];
    qrCode: null;
    globalSettings: {
        id_attribute: undefined;
        previousFilters: never[];
        previousPhases: never[];
        retries: number;
    };
    permissionSetsById: {
        [x: string]: {
            name: string;
            result: {
                userManagement: string[];
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            } | {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            } | {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            result: {
                auditlog: string[];
                userManagement?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                releases: {
                    "All releases": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                tenantManagement: string[];
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                deployments: string[];
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
            };
        } | {
            name: string;
            result: {
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
            };
        };
    };
    rolesById: {
        [x: string]: {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        };
    };
    settingsInitialized: boolean;
    showConnectDeviceDialog: boolean;
    showFeedbackDialog: boolean;
    showStartupNotification: boolean;
    tooltips: {
        byId: {};
    };
    userSettings: {
        columnSelection: never[];
        onboarding: {};
    };
    userSettingsInitialized: boolean;
}, {
    receivedQrCode: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    successfullyLoggedIn: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedUserList: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedActivationCode: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    createdUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    updatedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedPermissionSets: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedRoles: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    createdRole: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removedRole: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setCustomColumns: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setGlobalSettings: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setUserSettings: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setTooltipState: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setTooltipsState: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowFeedbackDialog: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowConnectingDialog: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowStartupNotification: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
}, "users", "users", _reduxjs_toolkit.SliceSelectors<{
    activationCode: undefined;
    byId: {};
    currentUser: null;
    currentSession: {};
    customColumns: never[];
    qrCode: null;
    globalSettings: {
        id_attribute: undefined;
        previousFilters: never[];
        previousPhases: never[];
        retries: number;
    };
    permissionSetsById: {
        [x: string]: {
            name: string;
            result: {
                userManagement: string[];
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            } | {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            } | {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            result: {
                auditlog: string[];
                userManagement?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                releases: {
                    "All releases": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                tenantManagement: string[];
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                deployments: string[];
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
            };
        } | {
            name: string;
            result: {
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
            };
        };
    };
    rolesById: {
        [x: string]: {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        };
    };
    settingsInitialized: boolean;
    showConnectDeviceDialog: boolean;
    showFeedbackDialog: boolean;
    showStartupNotification: boolean;
    tooltips: {
        byId: {};
    };
    userSettings: {
        columnSelection: never[];
        onboarding: {};
    };
    userSettingsInitialized: boolean;
}>>;
declare const actions: _reduxjs_toolkit.CaseReducerActions<{
    receivedQrCode: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    successfullyLoggedIn: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedUserList: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedActivationCode: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    createdUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    updatedUser: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedPermissionSets: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    receivedRoles: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    createdRole: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    removedRole: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setCustomColumns: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setGlobalSettings: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setUserSettings: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setTooltipState: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setTooltipsState: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowFeedbackDialog: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowConnectingDialog: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
    setShowStartupNotification: (state: immer.WritableDraft<{
        activationCode: undefined;
        byId: {};
        currentUser: null;
        currentSession: {};
        customColumns: never[];
        qrCode: null;
        globalSettings: {
            id_attribute: undefined;
            previousFilters: never[];
            previousPhases: never[];
            retries: number;
        };
        permissionSetsById: {
            [x: string]: {
                name: string;
                result: {
                    userManagement: string[];
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                } | {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                } | {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                result: {
                    auditlog: string[];
                    userManagement?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    releases: {
                        "All releases": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    tenantManagement: string[];
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    deployments?: undefined;
                    groups?: undefined;
                };
            } | {
                name: string;
                result: {
                    deployments: string[];
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                };
            } | {
                name: string;
                result: {
                    groups: {
                        "All devices": string[];
                    };
                    userManagement?: undefined;
                    auditlog?: undefined;
                    releases?: undefined;
                    tenantManagement?: undefined;
                    deployments?: undefined;
                };
            };
        };
        rolesById: {
            [x: string]: {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    auditlog: any[];
                    deployments: any[];
                    groups: {
                        "All devices": any[];
                    };
                    releases: {
                        "All releases": any[];
                    };
                    userManagement: any[];
                    tenantManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    releases: {
                        "All releases": any[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    groups: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            } | {
                name: string;
                value: string;
                description: string;
                permissions: never[];
                uiPermissions: {
                    groups: {
                        "All devices": string[];
                    };
                    auditlog: string[];
                    deployments?: string[];
                    releases: Record<string, string[]>;
                    tenantManagement: string[];
                    userManagement: string[];
                };
            };
        };
        settingsInitialized: boolean;
        showConnectDeviceDialog: boolean;
        showFeedbackDialog: boolean;
        showStartupNotification: boolean;
        tooltips: {
            byId: {};
        };
        userSettings: {
            columnSelection: never[];
            onboarding: {};
        };
        userSettingsInitialized: boolean;
    }>, action: {
        payload: any;
        type: string;
    }) => void;
}, "users">;
declare const _default: redux.Reducer<{
    activationCode: undefined;
    byId: {};
    currentUser: null;
    currentSession: {};
    customColumns: never[];
    qrCode: null;
    globalSettings: {
        id_attribute: undefined;
        previousFilters: never[];
        previousPhases: never[];
        retries: number;
    };
    permissionSetsById: {
        [x: string]: {
            name: string;
            result: {
                userManagement: string[];
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            } | {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            } | {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            result: {
                auditlog: string[];
                userManagement?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                releases: {
                    "All releases": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                tenantManagement: string[];
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                deployments?: undefined;
                groups?: undefined;
            };
        } | {
            name: string;
            result: {
                deployments: string[];
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
            };
        } | {
            name: string;
            result: {
                groups: {
                    "All devices": string[];
                };
                userManagement?: undefined;
                auditlog?: undefined;
                releases?: undefined;
                tenantManagement?: undefined;
                deployments?: undefined;
            };
        };
    };
    rolesById: {
        [x: string]: {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                auditlog: any[];
                deployments: any[];
                groups: {
                    "All devices": any[];
                };
                releases: {
                    "All releases": any[];
                };
                userManagement: any[];
                tenantManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                releases: {
                    "All releases": any[];
                };
                auditlog: string[];
                deployments?: string[];
                groups: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        } | {
            name: string;
            value: string;
            description: string;
            permissions: never[];
            uiPermissions: {
                groups: {
                    "All devices": string[];
                };
                auditlog: string[];
                deployments?: string[];
                releases: Record<string, string[]>;
                tenantManagement: string[];
                userManagement: string[];
            };
        };
    };
    settingsInitialized: boolean;
    showConnectDeviceDialog: boolean;
    showFeedbackDialog: boolean;
    showStartupNotification: boolean;
    tooltips: {
        byId: {};
    };
    userSettings: {
        columnSelection: never[];
        onboarding: {};
    };
    userSettingsInitialized: boolean;
}>;

export { actions, _default as default, initialState, sliceName, usersSlice };
